# Antkeeper Source

Antkeeper is an ant colony simulation game currently in development for Windows, Mac OS X, and GNU/Linux. This repository contains all of the source code to Antkeeper.

Head over to [antkeeper.com](https://antkeeper.com/) if you're interested in following the development of the game or purchasing a copy when it's released. Antkeeper is an indie game with a single developer, so feel free to reach out to me personally with any questions, comments, or feedback you may have.

## Configuration & Building

CMake is required to configure and build the application. Depending on the target build platform, CMake should be invoked from one of the following directories:

	build/linux32 // 32-bit GNU/Linux application
	build/linux64 // 64-bit GNU/Linux application
	build/win32   // 32-bit Windows application
	build/win64   // 64-bit Windows application

The following arguments may be passed to CMake during configuration:

	-DCMAKE_BUILD_TYPE // [Debug, Release]

### GNU/Linux

Building on GNU/Linux requires CMake, GCC, G++, and GNU Make. Open a terminal in the project root directory and run the following commands:

	cd build/linux64
	cmake ../.. -G "Unix Makefiles" -DCMAKE_BUILD_TYPE=...
	cmake --build .

### Windows

Building on Windows requires CMake and Visual Studio. Additionally, [NSIS](http://nsis.sourceforge.net/) is required if you want to build a distributable installer program. In order to correctly build for your target architecture, you must use the `x86 Native Tools Command Prompt` or the `x64 Native Tools Command Prompt` for 32-bit and 64-bit applications, respectively. Then navigate to the project root directory and run the following commands:

	cd build\win64
	cmake ..\.. -G "NMake Makefiles" -DCMAKE_BUILD_TYPE=...
	cmake --build .

## License

Antkeeper source code is licensed under the GNU General Public License, version 3. For more information, see [LICENSE.md](./LICENSE.md).

### 3rd-Party Software

| Name                            | Author(s)              | License                     | File(s)                                                  |
| :------------------------------ | :--------------------- | :-------------------------- | :------------------------------------------------------- |
| dr_wav                          | David Reid             | Public Domain (Unlicense)   | [dr_wav.h](./src/dr_libs/dr_wav.h)                       |
| Easing Functions (Equations)    | Robert Penner          | MIT License                 | [easings.hpp](./src/antkeeper/animation/easings.hpp)     |
| EnTT                            | Michele Caini          | MIT License                 | *Not included in repository*                             |
| khrplatform.h                   | The Khronos Group Inc. | MIT License                 | [khrplatform.h](./src/glad/khrplatform.h)                |
| OpenGL loader generated by glad | David Herberth         | Public Domain / WTFPL / CC0 | [glad.h](./src/glad/glad.h), [glad.c](./src/glad/glad.c) |
| JSON for Modern C++             | Niels Lohmann          | MIT License                 | [json.hpp](./src/nlohmann/json.hpp)                      |
| OpenAL Soft                     |                        | GNU GPL v2.0                | *Not included in repository*                             |
| Simple DirectMedia Layer        | Sam Lantinga           | zlib License                | *Not included in repository*                             |
| stb_image                       | Sean Barrett           | Public Domain / MIT License | [stb_image.h](./src/stb/stb_image.h)                     |
| stb_image_write                 | Sean Barrett           | Public Domain / MIT License | [stb_image_write.h](./src/stb/stb_image_writer.h)        |

